summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMichał Górny <mgorny@gentoo.org>2017-08-13 00:15:48 +0200
committerMichał Górny <mgorny@gentoo.org>2017-11-20 18:34:02 +0100
commit333acdfca16e2dfef81f65ddc6fce8e91405b8ac (patch)
tree74b931ffe21f429947783f41699ef108abf67870 /eclass/out-of-source.eclass
parentdev-python/collectd-rabbitmq: remove PYTHON_TARGETS != python2_7. (diff)
downloadgentoo-333acdfca16e2dfef81f65ddc6fce8e91405b8ac.tar.gz
gentoo-333acdfca16e2dfef81f65ddc6fce8e91405b8ac.tar.bz2
gentoo-333acdfca16e2dfef81f65ddc6fce8e91405b8ac.zip
out-of-source.eclass: A new eclass to help with out-of-source builds
The out-of-source.eclass is a simple multilib-minimal-style wrapper to perform out of source builds of autotools (and other) packages. It is mostly derived from the function served in the past by autotools-utils since a number of developers found it useful. However, in order to avoid the mistakes of autotools-utils, it is meant to be focused on a single feature and have a better API. This eclass has two use cases: 1. Ensuring that packages are tested with out-of-source builds. 2. Improving consistency between multilib and non-multilib packages. In the most basic form, it just redefines the phases from src_configure() to src_install() with out-of-source wrappers. However, each phase can be overriden using my_src_*() sub-phase that is run inside build dir (alike multilib_src_*() in multilib-minimal). There is also my_src_install_all() for the trailing source-dir actions.
Diffstat (limited to 'eclass/out-of-source.eclass')
-rw-r--r--eclass/out-of-source.eclass124
1 files changed, 124 insertions, 0 deletions
diff --git a/eclass/out-of-source.eclass b/eclass/out-of-source.eclass
new file mode 100644
index 00000000000..4d9c8d05fd6
--- /dev/null
+++ b/eclass/out-of-source.eclass
@@ -0,0 +1,124 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+# @ECLASS: out-of-source.eclass
+# @MAINTAINER:
+# Michał Górny <mgorny@gentoo.org>
+# @BLURB: convenient wrapper to build autotools packages out-of-source
+# @DESCRIPTION:
+# This eclass provides a minimalistic wrapper interface to easily
+# build autotools (and alike) packages out-of-source. It is meant
+# to resemble the interface used by multilib-minimal without actually
+# requiring the package to be multilib.
+#
+# For the simplest ebuilds, it is enough to inherit the eclass
+# and the new phase functions will automatically build the package
+# out-of-source. If you need to redefine one of the default phases
+# src_configure() through src_install(), you need to define
+# the matching sub-phases: my_src_configure(), my_src_compile(),
+# my_src_test() and/or my_src_install(). Those sub-phase functions
+# will be run inside the build directory. Additionally,
+# my_src_install_all() is provided to perform doc-install and other
+# common tasks that are done in source directory.
+#
+# Example use:
+# @CODE
+# inherit out-of-source
+#
+# my_src_configure() {
+# econf \
+# --disable-static
+# }
+# @CODE
+
+case ${EAPI} in
+ 6);;
+ *) die "EAPI ${EAPI:-0} unsupported (too old)";;
+esac
+
+EXPORT_FUNCTIONS src_configure src_compile src_test src_install
+
+if [[ ! ${_OUT_OF_SOURCE_ECLASS} ]]; then
+
+# @FUNCTION: out-of-source_src_configure
+# @DESCRIPTION:
+# The default src_configure() implementation establishes a BUILD_DIR,
+# sets ECONF_SOURCE to the current directory (usually S), and runs
+# my_src_configure() (or the default) inside it.
+out-of-source_src_configure() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ # set some BUILD_DIR if we don't have one yet
+ : "${BUILD_DIR:=${WORKDIR}/${P}_build}"
+ local ECONF_SOURCE=${PWD}
+
+ mkdir -p "${BUILD_DIR}" || die
+ pushd "${BUILD_DIR}" >/dev/null || die
+ if declare -f my_src_configure >/dev/null ; then
+ my_src_configure
+ else
+ default_src_configure
+ fi
+ popd >/dev/null || die
+}
+
+# @FUNCTION: out-of-source_src_compile
+# @DESCRIPTION:
+# The default src_compile() implementation runs my_src_compile()
+# (or the default) inside the build directory.
+out-of-source_src_compile() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ pushd "${BUILD_DIR}" >/dev/null || die
+ if declare -f my_src_compile >/dev/null ; then
+ my_src_compile
+ else
+ default_src_compile
+ fi
+ popd >/dev/null || die
+}
+
+# @FUNCTION: out-of-source_src_test
+# @DESCRIPTION:
+# The default src_test() implementation runs my_src_test()
+# (or the default) inside the build directory.
+out-of-source_src_test() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ pushd "${BUILD_DIR}" >/dev/null || die
+ if declare -f my_src_test >/dev/null ; then
+ my_src_test
+ else
+ default_src_test
+ fi
+ popd >/dev/null || die
+}
+
+# @FUNCTION: out-of-source_src_install
+# @DESCRIPTION:
+# The default src_install() implementation runs my_src_install()
+# (or the 'make install' part of the default) inside the build directory,
+# followed by a call to my_src_install_all() (or 'einstalldocs' part
+# of the default) in the original working directory.
+out-of-source_src_install() {
+ debug-print-function ${FUNCNAME} "$@"
+
+ pushd "${BUILD_DIR}" >/dev/null || die
+ if declare -f my_src_install >/dev/null ; then
+ my_src_install
+ else
+ if [[ -f Makefile || -f GNUmakefile || -f makefile ]] ; then
+ emake DESTDIR="${D}" install
+ fi
+ fi
+ popd >/dev/null || die
+
+ if declare -f my_src_install_all >/dev/null ; then
+ my_src_install_all
+ else
+ einstalldocs
+ fi
+}
+
+_OUT_OF_SOURCE_ECLASS=1
+fi